package com.rshy.project.hy.cache;

import cn.hutool.extra.spring.SpringUtil;
import org.springframework.stereotype.Component;

/**
 * @author dxy
 * @description: 缓存工具类
 * @date 2021/4/5 16:48
 */
@Component
public class CacheUtil {

    private static ICache getCache() {
        return SpringUtil.getBean(StarshowCacheManager.class).getCache();
    }

    public static <T> T get(String cacheName, Object key) {
        return getCache().get(cacheName, key);
    }

    public static void put(String cacheName, Object key, Object value) {
        getCache().put(cacheName, key, value);
    }

    public static void put(String cacheName, Object key, Object value, int liveSeconds) {
        getCache().put(cacheName, key, value, liveSeconds);
    }

    public static void remove(String cacheName, Object key) {
        getCache().remove(cacheName, key);
    }

    public static void removeAll(String cacheName) {
        getCache().removeAll(cacheName);
    }

    public static String genCacheKey(String prefix, Object keyValue) {
        return prefix + keyValue;
    }



}
