package com.rshy.project.hy.cache;

/**
 * @author dxy
 * @description: 缓存接口
 * @date 2021/4/5 16:48
 */
public interface ICache {

    /**
     * 读缓存
     * @param cacheName
     * @param key
     * @param <T>
     * @return
     */
    <T> T get(String cacheName, Object key);

    /**
     * 写缓存
     * @param cacheName
     * @param key
     * @param value
     */
    void put(String cacheName, Object key, Object value);

    /**
     * 写缓存，缓存时间，秒
     * @param cacheName
     * @param key
     * @param value
     * @param liveSeconds
     */
    void put(String cacheName, Object key, Object value, int liveSeconds);

    /**
     * 删除缓存
     * @param cacheName
     * @param key
     */
    void remove(String cacheName, Object key);

    /**
     * 删除所有cacheName下缓存
     * @param cacheName
     */
    void removeAll(String cacheName);

}
