package com.rshy.project.hy.task;

import com.rshy.project.hy.model.entity.RshyJk;
import com.rshy.project.hy.server.RshyServer;
import com.rshy.project.hy.service.RshyJkService;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;
import java.util.List;

/**
 * @author: lileilei
 * @date: 2022/4/20 15:44
 * @description:
 */
@Component
@Slf4j
public class RshyJkJob {
    @Autowired
    private RshyJkService rshyJkService;
    @Autowired
    private RshyServer rshyServer;

    /**
     * 每十分钟执行一次
     */
    @Async
    @Scheduled(cron = "0 0/10 * * * ?")
    public void taskRshy() {
        log.info("第三方接口服务状态调用 start");
        List<RshyJk> rshyError = rshyJkService.getRshyError();
        if (CollectionUtils.isEmpty(rshyError)) {
            return;
        }
        rshyError.forEach(rshyJk -> {
            String map = rshyServer.getMap("412728199706030513", rshyJk, "ff70eae2e37a6e6ce7ff34d0a9e92f5d");
            if (StringUtils.isNotBlank(map)) {
                rshyJk.setErrCount(0);
                rshyJk.updateById();
            }
        });
        log.info("第三方接口服务状态调用 end");
    }
}
